datablock AudioProfile(FWammogetSound)
{
	filename = "./FWammoget.wav";
	description = AudioClosest3d;
	preload = false;
};

datablock ItemData(BlastRoundsStaticItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "./AMMO_BlastRounds.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Ammo, Blast Round";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	canDrop = true;

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "BlastRounds 8";
};

function BlastRoundsStaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	%obj.rotate = true;
	%obj.setShapeName(getWord(%obj.TT_ammoPickup[0], 1));
	Parent::onAdd(%this, %obj);
}

datablock ItemData(FWPilestaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./ammoPileB.dts";
	uiName = "Ammo Pile B";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "21Gauge -1";
	TT_ammoPickup[1] = "45Caliber -1";
	TT_ammoPickup[2] = "ImpactGrenade -1";
	TT_ammoPickup[3] = "SmokeGrenade -1";
	TT_ammoPickup[4] = "Slugs -1";
	TT_ammoPickup[5] = "BlastRounds -1";
};

function FWPilestaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	Parent::onAdd(%this, %obj);
}

datablock ItemData(FWHeavyPilestaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./ammoHeavyCache.dts";
	uiName = "Ammo Heavy Cache";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "Payload -1";
	TT_ammoPickup[1] = "StrikeRocket -1";
	TT_ammoPickup[2] = "50Cal -1";
};

function FWHeavyPileStaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	Parent::onAdd(%this, %obj);
}

datablock ItemData(TwentyOneGaugeStaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./AMMO_21gauge.dts";
	uiName = "Ammo, 21 Gauge";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "21Gauge 12";
};

function TwentyOneGaugeStaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	%obj.rotate = true;
	%obj.setShapeName(getWord(%obj.TT_ammoPickup[0], 1));
	Parent::onAdd(%this, %obj);
}

datablock ItemData(ImpactGrenadeStaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./AMMO_ImpactGrenade_.dts";
	uiName = "Ammo, Impact Grenade";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "ImpactGrenade 4";
};

function ImpactGrenadeStaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	%obj.rotate = true;
	%obj.setShapeName(getWord(%obj.TT_ammoPickup[0], 1));
	Parent::onAdd(%this, %obj);
}

datablock ItemData(SmokeGrenadeStaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./AMMO_SmokeGrenade.dts";
	uiName = "Ammo, Smoke Grenade";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "SmokeGrenade 4";
};

function SmokeGrenadeStaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	%obj.rotate = true;
	%obj.setShapeName(getWord(%obj.TT_ammoPickup[0], 1));
	Parent::onAdd(%this, %obj);
}

datablock ItemData(fortyfivecaliberstaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./ammo_45caliber.dts";
	uiName = "Ammo,.45 Caliber";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "45Caliber 24";
};

function fortyfivecaliberstaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	%obj.rotate = true;
	%obj.setShapeName(getWord(%obj.TT_ammoPickup[0], 1));
	Parent::onAdd(%this, %obj);
}

datablock ItemData(SlugStaticItem : BlastRoundsStaticItem)
{
	shapeFile = "./AMMO_Slugs.dts";
	uiName = "Ammo, Slug";

	TT_pickupSound = FWammogetSound;
	TT_ammoPickup = true;
	TT_ammoPickup[0] = "Slugs 6";
};

function SlugStaticItem::onAdd(%this, %obj)
{
	%this.TT_initAmmoPickup(%obj);
	%obj.rotate = true;
	%obj.setShapeName(getWord(%obj.TT_ammoPickup[0], 1));
	Parent::onAdd(%this, %obj);
}
