datablock ParticleData(ballisticShotgunTrailParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0.15;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 805;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin     = -150.0;
   spinRandomMax     = 150.0;
   colors[0]     = "1.0 1.0 1.0 0.2";
   colors[1]     = "0.8 0.8 0.8 0.1";
   colors[2]     = "0.6 0.6 0.6 0.05";
   colors[3]     = "0.4 0.4 0.4 0.025";

   sizes[0]      = 0.2;
   sizes[1]      = 0.1;
   sizes[2]      = 0.05;
   sizes[3]      = 0.025;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.5;
   times[3] = 2.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(ballisticShotgunTrailEmitter)
{
   ejectionPeriodMS = 2; //5
   periodVarianceMS = 1;
   ejectionVelocity = -0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180; //90
   phiReferenceVel  = 0;
   phiVariance      = 0; //360
   overrideAdvance = false;
   particles = "ballisticShotgunTrailParticle";

   uiName = "Slug Shotgun Trail";
};


AddDamageType("ballisticShotgun",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_ballisticShotgun> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_ballisticShotgun> %1',0.75,1);
AddDamageType("ballisticShotgunHeadshot",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_ballisticShotgun>  <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_FWHeadshot>%1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_ballisticShotgun> <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_FWHeadshot>%1',0.75,1);
datablock ProjectileData(ballisticShotgunProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Frogs_Weaponry/Slug.dts";
   directDamage        = 55; //14;
   directDamageType    = $DamageType::ballisticShotgun;
   radiusDamageType    = $DamageType::ballisticShotgun;
   particleEmitter     = ballisticShotgunTrailEmitter;

   brickExplosionRadius = 0.2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 3000; //500
   verticalImpulse     = 250;
   explosion           = gunExplosion;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.4;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(ballisticShotgunItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./ballisticShotgun.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Ballistic Shotgun";
   iconName = "./icon_ballisticShotgun";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

    // Dynamic properties defined by the scripts
   image = ballisticShotgunImage;
   canDrop = true;

   TT_ammoType = "Slugs";
   TT_reloads = true;
   TT_maxAmmo = 6;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ballisticShotgunImage)
{
   // Basic Item properties
   shapeFile = "./ballisticShotgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ballisticShotgunItem;
   ammo = " ";
   projectile = ballisticShotgunProjectile;
   projectileType = Projectile;

   casing = BreakShotgunShellDebris;
   shellExitDir        = "-0.2 1.0 1.75"; //-1.0 1.0 1.0
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;

   doColorShift = true;
   colorShiftColor = ballisticShotgunItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                    = "Activate";
   stateTimeoutValue[0]            = 0.128; //0.15
   stateTransitionOnTimeout[0]     = "DeathCheckA";
   stateSound[0]          = weaponSwitchSound;

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "FireCheckA";
   stateTransitionOnNotLoaded[1]    = "ReloadCheckA";
   stateScript[1]                  = "onReady";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Smoke";
   stateTimeoutValue[2]            = 0.1;
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateScript[2]                  = "onFire";
   stateEmitter[2]         = gunFlashEmitter;
   stateEmitterTime[2]    = 0.025; //0.05
   stateEmitterNode[2]     = "muzzleNode";

   stateName[3]           = "Smoke";
   stateTimeoutValue[3]            = 0.192; //0.2
   stateTransitionOnTimeout[3]     = "DeathCheckA";
   stateEmitter[3]        = gunSmokeEmitter;
   stateEmitterTime[3]    = 0.5; //0.05
   stateEmitterNode[3]     = "muzzleNode";

   // When splitting up the Timeout of a state only 32 ms ticks really count, rounded up
   // 0.01 gets rounded up to 0.032 ms or 1 tick
   // 0.5 / 0.032 = 15.625 -> 16 ticks
   // 15 + 1 -> 15 * 0.032 + 1 * 0.032 = 0.48 + 0.032 ms
   stateName[4]           = "Eject";
   stateTimeoutValue[4]      = 0.48; //0.5
   stateTransitionOnTimeout[4]     = "LoadCheckA";
   stateEjectShell[4]           = true;
   stateSequence[4]          = "pump";
   stateSound[4]          = ballisticShotgunReloadSound;
   stateScript[4]                  = "onEject";

   // Would run LoadCheck during Eject but that broke the eject animation for TTAmmo 2/3
   // Some weird interaction with DeathCheck?
   stateName[5]            = "LoadCheckA";
   stateTimeoutValue[5]    = 0.01;
   stateScript[5]          = "TT_onLoadCheck";
   stateTransitionOnTimeout[5] = "WaitForTriggerUp";

   // Loaded - gun has ammo, doesn't need reload
   // NotLoaded - empty gun, needs reload
   // Ammo - reserve ammo available, can reload
   // NoAmmo - no reserve ammo left, can't reload
   // Loaded/NotLoaded goes before Ammo/NoAmmo transitions
   stateName[6]            = "LoadCheckB";
   stateTransitionOnLoaded[6]    = "Ready";
   stateTransitionOnAmmo[6]      = "Reload";
   stateTransitionOnNoAmmo[6]    = "Empty";

   stateName[7]            = "ReloadCheckA";
   stateScript[7]          = "TT_onReloadCheck";
   stateTimeoutValue[7]       = 0.01;
   stateTransitionOnTimeout[7]      = "ReloadCheckB";

   stateName[8]            = "ReloadCheckB";
   stateTransitionOnLoaded[8]    = "CompleteReload";
   stateTransitionOnNotLoaded[8]    = "LoadCheckB";

   stateName[9]                  = "Empty";
   stateTransitionOnLoaded[9]      = "Ready";
   stateTransitionOnAmmo[9]       = "Reload";
   stateTransitionOnTriggerDown[9] = "FireCheckA";

   stateName[10]                    = "EmptyFire";
   stateScript[10]                  = "TT_onEmptyFire";
   stateTimeoutValue[10]            = 0.32; // delay roughly equal to Fire + Smoke
   stateTransitionOnTimeout[10]   = "DeathCheckA";
   stateSound[10]                   = PumpShotgunJamSound;

   stateName[11]           = "Reload";
   stateTransitionOnTimeout[11]        = "Reloaded";
   stateTransitionOnTriggerDown[11]    = "FireCheckA";
   stateTimeoutValue[11]         = 0.25;
   stateScript[11]            = "onReloadStart";

   stateName[12]           = "Reloaded";
   stateTransitionOnTimeout[12]        = "ReloadCheckA";
   stateTimeoutValue[12]         = 0.2;
   stateScript[12]            = "onReloaded";

   stateName[13]          = "CompleteReload";
   stateTimeoutValue[13]        = 0.5;
   stateTransitionOnTimeout[13]        = "Ready";
   stateSequence[13]         = "pump";
   stateSound[13]         = ballisticShotgunReloadSound;
   stateScript[13]                  = "onEject";

   stateName[14]           = "FireCheckA";
   stateScript[14]         = "TT_onFireCheck";
   stateTimeoutValue[14]        = 0.01; // to keep timing consistent with original
   stateTransitionOnTimeout[14]        = "FireCheckB";

   stateName[15]                     = "FireCheckB";
   stateTransitionOnLoaded[15]       = "Fire";
   stateTransitionOnNotLoaded[15]    = "EmptyFire";

   // Don't know of a way to stop state animations/sounds from playing so let's add more checks
   // If player is dead this should stop them from completing the reload and playing an animation while dead
   // So much effort just to stop a dead guy from pumping their shotgun
   stateName[16]                  = "DeathCheckA";
   stateTimeoutValue[16]          = 0.032; // necessary to sync state with animation and sound
   stateScript[16]                = "TT_onDeathCheck";
   stateTransitionOnTimeout[16]   = "DeathCheckB";

   stateName[17]                  = "DeathCheckB";
   stateTransitionOnAmmo[17]      = "Eject";

   stateName[18]                  = "WaitForTriggerUp";
   stateTransitionOnTriggerUp[18]   = "LoadCheckB";
};

function ballisticShotgunImage::onFire(%this,%obj,%slot)
{
   serverPlay3D(ballisticShotgunfireSound,%obj.getPosition());
   %obj.playThread(2, activate);

   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

   %projectile = %this.projectile;
   %spread = 0.00025; //0.0010
   %shellcount = 1;

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function ballisticShotgunImage::onEject(%this,%obj,%slot)
{
   %obj.playThread(2, plant);
   %this.TT_displayAmmo(%obj);
}

function ballisticShotgunImage::onReloadStart(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %obj.playThread(2, shiftto);
   serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
   %this.TT_displayAmmo(%obj);
}

function ballisticShotgunImage::onReloaded(%this,%obj,%slot)
{
   // No check for DeathStopAnims since no anims/sounds here and it goes to ReloadCheckA after
   %this.TT_incrementReload(%obj, %slot);
   %this.TT_displayAmmo(%obj);
}

function ballisticShotgunProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   %multiplier = 2; // multiply damage by this on headshot
   TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, %multiplier, $DamageType::ballisticShotgunHeadshot);
}
