AddDamageType("BreakShotgun",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_BreakShotgun> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_BreakShotgun> %1',0.75,1);
datablock ProjectileData(BreakShotgunProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::BreakShotgun;
   radiusDamageType    = $DamageType::BreakShotgun;

   brickExplosionRadius = 0.2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 20;
   verticalImpulse     = 10;
   explosion           = gunExplosion;

   muzzleVelocity      = 125;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.8;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock DebrisData(BreakShotgunShellDebris)
{
   shapeFile = "./ShellRed.dts";
   lifetime = 2.0;
   minSpinSpeed = -400.0;
   maxSpinSpeed = 200.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 3;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;

   gravModifier = 2;
};


//////////
// item //
//////////
datablock ItemData(BreakShotgunItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./BreakShotgun.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Break Shotgun";
   iconName = "./icon_BreakShotgun";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

    // Dynamic properties defined by the scripts
   image = BreakShotgunImage;
   canDrop = true;

   TT_ammoType = "Shotgun";
   TT_reloads = true;
   TT_maxAmmo = 1;
   TT_alwaysReloadPref = "NonEx";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BreakShotgunImage)
{
   // Basic Item properties
   shapeFile = "./BreakShotgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BreakShotgunItem;
   ammo = " ";
   projectile = BreakShotgunProjectile1;
   projectileType = Projectile;

   casing = BreakShotgunShellDebris;
   shellExitDir        = "-0.2 1.0 1.75"; //-1.0 1.0 1.0
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BreakShotgunItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                    = "Activate";
   stateTimeoutValue[0]            = 0.15;
   stateSequence[0]     = "Activate";
   stateTransitionOnTimeout[0]     = "LoadCheckA";
   stateSound[0]        = weaponSwitchSound;

   stateName[1]                    = "Ready";
   stateTransitionOnNotLoaded[1] = "ReloadWait";
   stateTransitionOnTriggerDown[1] = "FireCheckA";
   stateAllowImageChange[1]        = true;
   stateScript[1]                  = "onReady";
   stateSequence[1]          = "ready";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Smoke";
   stateTimeoutValue[2]            = 0.025;
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateScript[2]                  = "onFire";
   stateWaitForTimeout[2]     = true;
   stateEmitter[2]         = gunFlashEmitter;
   stateEmitterTime[2]     = 0.05;
   stateEmitterNode[2]     = "muzzleNode";
   stateSound[2]        = BreakShotgunFireSound;

   stateName[3]         = "Smoke";
   stateEmitter[3]         = gunSmokeEmitter;
   stateEmitterTime[3]     = 0.05;
   stateEmitterNode[3]     = "muzzleNode";
   stateTransitionOnTriggerUp[3] = "Wait";

   stateName[4]         = "Wait";
        stateTimeoutValue[4]     = 0.2;
   stateTransitionOnTimeout[4]   = "LoadCheckA";

   //Torque switches states instantly if there is an ammo/NotLoaded state, regardless of stateWaitForTimeout
   stateName[5]            = "LoadCheckA";
   stateScript[5]          = "TT_onLoadCheck";
   stateTimeoutValue[5]       = 0.01;
   stateTransitionOnTimeout[5]      = "LoadCheckB";

   stateName[6]            = "LoadCheckB";
   stateTransitionOnLoaded[6]    = "Ready";
   stateTransitionOnNotLoaded[6]    = "Empty";

   stateName[7]            = "ReloadWait";
   stateTimeoutValue[7]       = 0.3;
   stateEjectShell[7]              = true;
   stateScript[7]          = "onReloadWait";
   stateSequence[7]               = "BreakOpen";
   stateTransitionOnTimeout[7]      = "ReloadStart";
   stateWaitForTimeout[7]        = true;

   stateName[8]            = "ReloadStart";
   stateTimeoutValue[8]       = 1.1;
   stateScript[8]          = "onReloadStart";
   stateTransitionOnTimeout[8]      = "Reloaded";
   stateWaitForTimeout[8]        = true;

   stateName[9]            = "Reloaded";
   stateTimeoutValue[9]       = 0.192; // 0.2
   stateScript[9]          = "onReloaded";
   stateTransitionOnTimeout[9]    = "DeathCheck";

   stateName[10]              = "Breakclose";
   stateTimeoutValue[10]         = 0.1;
   stateScript[10]               = "onBreakclose";
   stateSequence[10]             = "BreakClose";
   stateSound[10]                = "FWReload1Sound";
   stateTransitionOnTimeout[10]  = "Ready";

   stateName[11]                = "BreakcloseCheck";
   stateTransitionOnAmmo[11]    = "Breakclose";

    stateName[12]                     = "FireCheckA";
   stateScript[12]                   = "TT_onFireCheck";
   stateTransitionOnTimeout[12]      = "FireCheckB";

   stateName[13]                     = "FireCheckB";
   stateTransitionOnLoaded[13]       = "Fire";
   stateTransitionOnNotLoaded[13]    = "EmptyFire";

   stateName[14]                    = "Empty";
   stateTransitionOnLoaded[14]      = "Ready";
   stateTransitionOnAmmo[14]        = "ReloadWait";
   stateTransitionOnTriggerDown[14] = "FireCheckA";

   stateName[15]                    = "EmptyFire";
   stateScript[15]                  = "TT_onEmptyFire";
   stateTransitionOnLoaded[15]      = "Ready";
   stateTransitionOnAmmo[15]        = "ReloadWait";
   stateTransitionOnTriggerUp[15]   = "Empty";

   stateName[16]                    = "DeathCheck";
   stateScript[16]                  = "TT_onDeathCheck";
   stateTimeoutValue[16]            = 0.032;
   stateTransitionOnTimeout[16]     = "Breakclosecheck";
};

function BreakShotgunImage::onFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   if(vectorLen(%obj.getVelocity()) < 0.1)
   {
      %spread = 0.0025; //0.002
   }
   else
   {
      %spread = 0.0027; //0.0025
   }
   %shellcount = 8;

   %obj.playThread(2, shiftaway);

   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTHugeRecoilProjectile,"1 1 1");

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function BreakShotgunImage::onReloadStart(%this,%obj,%slot)
{
   %this.TT_displayAmmo(%obj);
}

function BreakShotgunImage::onReloaded(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return %obj.setImageLoaded(%slot, 1);
   %this.TT_reload(%obj, %slot, Block_PlantBrick_Sound, plant);
   %this.TT_displayAmmo(%obj);
}

function BreakShotgunImage::onBreakclose(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, shiftUp);
}

function BreakShotgunImage::onReloadWait(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, shiftUp);
   serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}
