datablock ParticleData(HawkeyeTrailParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0.15;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 805;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin     = -150.0;
   spinRandomMax     = 150.0;
   colors[0]     = "1.0 1.0 1.0 0.9";
   colors[1]     = "0.8 0.8 0.8 0.8";
   colors[2]     = "0.6 0.6 0.6 0.6";
   colors[3]     = "0.4 0.4 0.4 0.4";

   sizes[0]      = 0.2;
   sizes[1]      = 0.1;
   sizes[2]      = 0.05;
   sizes[3]      = 0.02;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.5;
   times[3] = 2.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(HawkeyeTrailEmitter)
{
   ejectionPeriodMS = 2; //5
   periodVarianceMS = 1;
   ejectionVelocity = -0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0; //90
   phiReferenceVel  = 0;
   phiVariance      = 0; //360
   overrideAdvance = false;
   particles = "HawkeyeTrailParticle";

   uiName = "Hawkeye Trail";
};

AddDamageType("Hawkeye",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Hawkeye> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Hawkeye> %1',0.75,1);
AddDamageType("HawkeyeHeadshot",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Hawkeye>  <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_FWHeadshot>%1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Hawkeye> <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_FWHeadshot>%1',0.75,1);
datablock ProjectileData(HawkeyeProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 75;
   directDamageType    = $DamageType::Hawkeye;
   radiusDamageType    = $DamageType::Hawkeye;
   particleEmitter     = HawkeyeTrailEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 20;
   verticalImpulse     = 10;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.05; //0.7

   explodeOnDeath = true;
   explodeOnPlayerImpact = true;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(HawkeyeItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./Hawkeye.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Hawkeye";
   iconName = "./icon_Hawkeye";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

    // Dynamic properties defined by the scripts
   image = HawkeyeImage;
   canDrop = true;

    TT_ammoType = "270";
    TT_reloads = true;
    TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HawkeyeImage)
{
   // Basic Item properties
   shapeFile = "./Hawkeye.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HawkeyeItem;
   ammo = " ";
   projectile = HawkeyeProjectile1;
   projectileType = Projectile;

   casing = BigShellDebris;
   shellExitDir        = "1.0 1.0 1.0"; //1.0 0.1 1.0
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HawkeyeItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                    = "Activate";
   stateTimeoutValue[0]            = 0.15;
   stateSequence[0]     = "Activate";
   stateTransitionOnTimeout[0]     = "LoadCheckA";
   stateSound[0]        = weaponSwitchSound;

   stateName[1]                    = "Ready";
   stateTransitionOnNotLoaded[1] = "ManualReload";
   stateTransitionOnTriggerDown[1] = "FireCheckA";
   stateAllowImageChange[1]        = true;
   stateScript[1]                  = "onReady";
   stateSequence[1]          = "ready";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Smoke";
   stateTimeoutValue[2]            = 0.025;
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateScript[2]                  = "onFire";
   stateWaitForTimeout[2]     = true;
   stateEmitter[2]         = gunFlashEmitter;
   stateEmitterTime[2]     = 0.05;
   stateEmitterNode[2]     = "muzzleNode";
   stateSound[2]        = HawkeyeSniperfireSound;

   stateName[3]         = "Smoke";
   stateEmitter[3]         = gunSmokeEmitter;
   stateEmitterTime[3]     = 0.05;
   stateEmitterNode[3]     = "muzzleNode";
   stateTransitionOnTriggerUp[3] = "BoltWait";

   stateName[4]         = "Wait";
   stateTimeoutValue[4]    = 0.2;
   stateTransitionOnTimeout[4]   = "LoadCheckA";

   //Torque switches states instantly if there is an ammo/NotLoaded state, regardless of stateWaitForTimeout
   stateName[5]            = "LoadCheckA";
   stateScript[5]          = "TT_onLoadCheck";
   stateTimeoutValue[5]       = 0.01;
   stateTransitionOnTimeout[5]      = "LoadCheckB";

   stateName[6]            = "LoadCheckB";
   stateTransitionOnLoaded[6]    = "Ready";
   stateTransitionOnNotLoaded[6]    = "Empty";

   stateName[7]            = "ReloadWait";
   stateTimeoutValue[7]       = 0.3;
   stateScript[7]          = "";
   stateTransitionOnTimeout[7]      = "ReloadStart";
   stateWaitForTimeout[7]        = true;

   stateName[8]            = "ReloadStart";
   stateTimeoutValue[8]       = 1.4;
   stateScript[8]          = "onReloadStart";
   stateTransitionOnTimeout[8]      = "Reloaded";
   stateWaitForTimeout[8]        = true;

   stateName[9]            = "Reloaded";
   stateTimeoutValue[9]       = 0.3;
   stateScript[9]          = "onReloaded";
        stateTransitionOnTimeout[9]    = "Ready";

         stateName[10]        = "Bolt";
   stateEjectShell[10]              = true;
   stateSequence [10]              = "reload";
   stateScript[10]                 = "OnBolt";
   stateTimeoutValue[10]      = 0.3;
   stateTransitionOnTimeout[10]  = "Wait";

   stateName[11]                  = "BoltWait";
   stateTimeoutValue[11]          = 0.672; // 0.7
   stateTransitionOnTimeout[11]   = "DeathCheckA";

    stateName[12]                    = "ManualReload";
   stateTransitionOnAmmo[12]        = "ReloadWait";
   stateTransitionOnNoAmmo[12]      = "ReloadStart";

   stateName[13]                     = "FireCheckA";
   stateScript[13]                   = "TT_onFireCheck";
   stateTransitionOnTimeout[13]      = "FireCheckB";

   stateName[14]                     = "FireCheckB";
   stateTransitionOnLoaded[14]       = "Fire";
   stateTransitionOnNotLoaded[14]    = "EmptyFire";

   stateName[15]                    = "Empty";
   stateTransitionOnLoaded[15]      = "Ready";
   stateTransitionOnAmmo[15]        = "ReloadWait";
   stateTransitionOnTriggerDown[15] = "FireCheckA";

   stateName[16]                    = "EmptyFire";
   stateScript[16]                  = "TT_onEmptyFire";
   stateTransitionOnLoaded[16]      = "Ready";
   stateTransitionOnAmmo[16]        = "ReloadWait";
   stateTransitionOnTriggerUp[16]   = "Empty";

   stateName[17]                  = "DeathCheckA";
   stateTimeoutValue[17]          = 0.032;
   stateScript[17]                = "TT_onDeathCheck";
   stateTransitionOnTimeout[17]   = "DeathCheckB";

   stateName[18]                  = "DeathCheckB";
   stateTransitionOnAmmo[18]      = "Bolt";
};

function HawkeyeImage::onFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   if(vectorLen(%obj.getVelocity()) < 0.1)
   {
      %spread = 0.0001; //0.0010
   }
   else
   {
      %spread = 0.0025; //0.0050
   }
   %shellcount = 1;

   %obj.playThread(2, plant);

   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function HawkeyeImage::onReloadStart(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %obj.playThread(2, shiftUp);
   serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
   %this.TT_displayAmmo(%obj);
}

function HawkeyeImage::onReloaded(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return %obj.setImageLoaded(%slot, 1);
   %this.TT_reload(%obj, %slot, FWReload1sound, plant);
   %this.TT_displayAmmo(%obj);
}

function HawkeyeProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   %multiplier = 3; // multiply damage by this on headshot
   TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, %multiplier, $DamageType::HawkeyeHeadshot);
}

function HawkeyeImage::onBolt(%this,%obj,%slot)
{
   // should be able to get away with no DeathStopAnims check since death check comes before
   %obj.playThread(2, plant);
   serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}
