AddDamageType("heavypistol",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/ci_HeavyPistol> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/ci_HeavyPistol> %1',0.75,1);
datablock ProjectileData(heavypistolProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 19;
   directDamageType    = $DamageType::heavypistol;
   radiusDamageType    = $DamageType::heavypistol;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 150; //150
   verticalImpulse     = 200;
   explosion           = gunExplosion;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(heavypistolItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./HeavyPistol.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Heavy Pistol";
   iconName = "./icon_HeavyPistol";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

    // Dynamic properties defined by the scripts
   image = heavypistolImage;
   canDrop = true;

   TT_ammoType = "45Caliber";
   TT_reloads = true;
   TT_maxAmmo = 12;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(heavypistolImage)
{
   // Basic Item properties
   shapeFile = "./HeavyPistol.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = heavypistolItem;
   ammo = " ";
   projectile = heavypistolProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.5 0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = heavypistolItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                    = "Activate";
   stateTimeoutValue[0]            = 0.15;
   stateSequence[0]     = "Activate";
   stateTransitionOnTimeout[0]     = "LoadCheckA";
   stateSound[0]        = weaponSwitchSound;

   stateName[1]                    = "Ready";
   stateTransitionOnNotLoaded[1] = "ManualReload";
   stateTransitionOnTriggerDown[1] = "FireCheckA";
   stateAllowImageChange[1]        = true;
   stateScript[1]                  = "onReady";
   stateSequence[1]          = "ready";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Smoke";
   stateTimeoutValue[2]            = 0.075;
   stateFire[2]                    = true;
   statesequence[2]                = "Fire";
    stateAllowImageChange[2]        = false;
    stateEjectShell[2]      = true;
   stateScript[2]                  = "onFire";
   stateWaitForTimeout[2]     = true;
   stateEmitter[2]         = gunFlashEmitter;
   stateEmitterTime[2]     = 0.05;
   stateEmitterNode[2]     = "muzzleNode";
   stateSound[2]        = HeavySMGFireSound;

   stateName[3]         = "Smoke";
   stateEmitter[3]         = gunSmokeEmitter;
   stateEmitterTime[3]     = 0.1; //0.05
   stateEmitterNode[3]     = "muzzleNode";
   stateTimeoutValue[3]        = 0.01;
   stateTransitionOnTimeout[3] = "LoadCheckA";

   //Torque switches states instantly if there is an ammo/NotLoaded state, regardless of stateWaitForTimeout
   stateName[4]            = "LoadCheckA";
   stateScript[4]          = "TT_onLoadCheck";
   stateTimeoutValue[4]       = 0.01;
   stateTransitionOnTimeout[4]      = "LoadCheckB";

   stateName[5]            = "LoadCheckB";
   stateTransitionOnLoaded[5]      = "Ready";
   stateTransitionOnNotLoaded[5]    = "Empty";

   stateName[6]            = "ReloadWait";
   stateTimeoutValue[6]       = 0.25;
   stateScript[6]          = "";
   stateTransitionOnTimeout[6]      = "ReloadStart";
   stateWaitForTimeout[6]        = true;

   stateName[7]            = "ReloadStart";
   stateTimeoutValue[7]       = 0.5;
   stateScript[7]          = "onReloadStart";
      stateTransitionOnTimeout[7]      = "Reloaded";
   stateWaitForTimeout[7]        = true;

   stateName[8]            = "Reloaded";
   stateTimeoutValue[8]       = 0.288; // 0.3
        stateScript[8]           = "onReloaded";
        stateTransitionOnTimeout[8]    = "DeathCheck";

   stateName[9]                    = "SliderClose";
   stateTimeoutValue[9]            = 0.3;
   stateScript[9]                   = "OnSliderClose";
   stateSound[9]                    = "PistolPullBackSound";
   stateSequence[9]                 = "Fire";
   stateTransitionOnTimeout[9]       = "Ready";

   stateName[10]                     = "SliderCloseCheck";
   stateTransitionOnAmmo[10]         = "SliderClose";

   stateName[11]                    = "ManualReload";
   stateTransitionOnAmmo[11]        = "ReloadWait";
   stateTransitionOnNoAmmo[11]      = "ReloadStart";

   stateName[12]                     = "FireCheckA";
   stateScript[12]                   = "TT_onFireCheck";
   stateTransitionOnTimeout[12]      = "FireCheckB";

   stateName[13]                     = "FireCheckB";
   stateTransitionOnLoaded[13]       = "Fire";
   stateTransitionOnNotLoaded[13]    = "EmptyFire";

   stateName[14]                    = "Empty";
   stateTransitionOnLoaded[14]      = "Ready";
   stateTransitionOnAmmo[14]        = "ReloadWait";
   stateTransitionOnTriggerDown[14] = "FireCheckA";

   stateName[15]                    = "EmptyFire";
   stateScript[15]                  = "TT_onEmptyFire";
   stateTransitionOnLoaded[15]      = "Ready";
   stateTransitionOnAmmo[15]        = "ReloadWait";
   stateTransitionOnTriggerUp[15]   = "Empty";

   stateName[16]                    = "DeathCheck";
   stateScript[16]                  = "TT_onDeathCheck";
   stateTimeoutValue[16]            = 0.032;
   stateTransitionOnTimeout[16]     = "SliderCloseCheck";
};

function heavypistolImage::onFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   %spread = 0.0025;
   %shellcount = 1;

   %obj.playThread(2, shiftAway); //plant

   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTLittleRecoilProjectile,"1 1 1");

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function heavypistolImage::onReloadStart(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, shiftLeft);
   serverPlay3D(block_MoveBrick_Sound, %obj.getPosition());
}

function heavypistolImage::onReloaded(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return %obj.setImageLoaded(%slot, 1);
   %this.TT_reload(%obj, %slot, block_PlantBrick_Sound, plant); // originally no sound
   %this.TT_displayAmmo(%obj);
}

function heavypistolProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.1);
   }
   Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}

function heavypistolImage::onSliderClose(%this,%obj,%slot)
{
   %obj.playThread(2, Plant);
}