datablock ParticleData(SmokeGrenadeSmokeParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 15000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.5 0.5 0.5 0.95";
   colors[1]     = "0.5 0.5 0.5 0.8";
   colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]	= 6.0;
	sizes[1]	= 11.0;
   sizes[2]	= 13.0;

	times[0]	= 0.0;
	times[1]	= 0.75;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(SmokeGrenadeSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0; //90
   thetaMax         = 180; //360
   phiReferenceVel  = 0;
   phiVariance      = 360; //180
   overrideAdvance = false;
   particles = "SmokeGrenadeSmokeParticle";
};
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

datablock ExplosionData(smokegrenadeExplosion)
{
   //explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = SmokeGrenadeSound;
   
   emitter[0] = smokegrenadeSmokeEmitter;
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";


   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 0;
   impulseForce = 0;

   damageRadius = 0;
   radiusDamage = 0;

//	uiName = "Impact Grenade Explosion";
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

AddDamageType("SmokeGrenadeDirect",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_SmokeGrenade> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_SmokeGrenade> %1',1,1);
datablock ProjectileData(SmokeGrenadeProjectile)
{
   projectileShapeName = "./SmokeGrenadeThrown.dts";
   directDamage        = 0;
   directDamageType = $DamageType::SmokeGrenadeDirect;
   radiusDamageType = $DamageType::SmokeGrenadeRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = smokegrenadeExplosion;
//   particleEmitter     = ImpactGrenadeTrailEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0; //30             
   brickExplosionMaxVolume = 0;  //30         //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 38; //50
   velInheritFactor    = 1.0;
   explodeOnPlayerImpact = false;
   explodeOnDeath        = true;

   armingDelay         = 1500;
   lifetime            = 8000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.3; //0.5
   bounceFriction      = 0.35; //0.2
   isBallistic         = true;
   gravityMod          = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "1 0 0.0";

   uiName = "Smoke Grenade";
};
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////
// item //
//////////
datablock ItemData(SmokeGrenadeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SmokeGrenade.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Smoke Grenade";
	iconName = "./icon_SmokeGrenade";
	l4ditemtype = "grenade";

	 // Dynamic properties defined by the scripts
	image = SmokeGrenadeImage;
	canDrop = true;

	TT_ammoType = "SmokeGrenade";
	TT_grenade = true;
};

datablock ShapeBaseImageData(SmokeGrenadeImage)
{
   // Basic Item properties
   shapeFile = "./SmokeGrenade.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SmokeGrenadeItem;
   ammo = " ";
   projectile = SmokeGrenadeProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.01;
	stateTransitionOnTimeout[0]	= "Delay";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                = "Delay";
	stateTimeoutValue[1]        = 0.096;
	stateTransitionOnTimeout[1] = "Ready";
	stateScript[1]              = "onDelay";

	stateName[2]			= "Ready";
	stateTransitionOnTriggerDown[2]	= "Charge";
	stateScript[2]             = "onReady";
	stateAllowImageChange[2]	= true;

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]	= "Armed";
	stateTimeoutValue[3]            = 0.1;
	stateWaitForTimeout[3]		= false;
	stateTransitionOnTriggerUp[3]	= "AbortCharge";
	stateScript[3]                  = "onCharge";
	stateAllowImageChange[3]        = false;

	stateName[4]			= "AbortCharge";
	stateTransitionOnTimeout[4]	= "Ready";
	stateTimeoutValue[4]		= 0.1;
	stateWaitForTimeout[4]		= true;
	stateScript[4]			= "onAbortCharge";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Armed";
	stateScript[5]			= "onArmed";
	stateTransitionOnTriggerUp[5]	= "Fire";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Fire";
	stateTransitionOnTimeout[6]	= "Ready";
	stateTimeoutValue[6]		= 0.5;
	stateFire[6]			= true;
	stateSequence[6]		= "fire";
	stateScript[6]			= "onFire";
	stateWaitForTimeout[6]		= true;
	stateAllowImageChange[6]	= false;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SmokeGrenadeImage::onArmed(%this, %obj, %slot)
{
	%this.TT_displayAmmo(%obj, 0);
	%obj.playthread(2, spearready);
	%obj.playthread(3, activate);
	// This flag will allow the image to fire even after death, but isn't set if Armed state is not held
	%obj.setImageAmmo(0, 0);
}

function SmokeGrenadeImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function SmokeGrenadeImage::onFire(%this, %obj, %slot)
{
	if((%obj.getDamagePercent() < 1.0 || !%obj.getImageAmmo(0)) && !%this.TT_needsAmmo(%obj))
	{
		%p = Parent::onFire(%this, %obj, %slot);
		%this.TT_decrementAmmo(%obj);
		%obj.playThread(2, spearthrow);
		if(%obj.getDamagePercent() < 1.0)
			%obj.playThread(3, activate);
		else
			%obj.playThread(0, activate);
		serverPlay3D(tierfraggrenadetossSound,%obj.getPosition());
	}

	if(%this.TT_needsAmmo(%obj))
	{
		%obj.unMountImage(0);
	}
	%this.TT_displayAmmo(%obj, 1);
	%obj.setImageAmmo(0, 1);
	return %p;
}

function SmokeGrenadeImage::onDelay(%this, %obj, %slot)
{
	%this.TT_displayAmmo(%obj, 0);
	if(%this.TT_needsAmmo(%obj))
	{
		%obj.unMountImage(0);
		// %obj.playThread(2, root);
		%obj.playThread(1, root);
		// %obj.playThread(0, root);
		%this.TT_displayAmmo(%obj, 1);
	}
}

function SmokeGrenadeImage::onReady(%this, %obj, %slot)
{
	%this.TT_displayAmmo(%obj, 0);
	if(%this.TT_needsAmmo(%obj))
	{
		%obj.unMountImage(0);
		// %obj.playThread(2, root);
		%obj.playThread(1, root);
		// %obj.playThread(0, root);
		%this.TT_displayAmmo(%obj, 1);
	}
}

function SmokeGrenadeImage::onCharge(%this, %obj, %slot)
{
	if(%this.TT_needsAmmo(%obj))
	{
		%obj.unMountImage(0);
		// %obj.playThread(2, root);
		%obj.playThread(1, root);
		// %obj.playThread(0, root);
		%this.TT_displayAmmo(%obj, 1);
	}
	else
	{
		%obj.playThread(2, jump);
	}
}

//function SmokeGrenadeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
//{
//	serverPlay3D(SmokeGrenadeBounceSound,%obj.getTransform());
//}
