datablock PlayerData(DeployedArmor : PlayerStandardArmor)
{
   runForce = 10000; //Huge number to prevent the player from sliding across the terrain like ice.
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
   jetEnergyDrain = 0;
   canJet = 0;

   uiName = "";
   showEnergyBar = false;

   runSurfaceAngle  = 55;
   jumpSurfaceAngle = 55;
};


AddDamageType("Vulcan",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Vulcan> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Vulcan> %1',0.75,1);
datablock ProjectileData(VulcanProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 18;
   directDamageType    = $DamageType::Vulcan;
   radiusDamageType    = $DamageType::Vulcan;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 20;
   verticalImpulse     = 10;
   explosion           = gunExplosion;

   muzzleVelocity      = 120;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.7;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(VulcanItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system

    // Basic Item Properties
   shapeFile = "./Vulcan.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   //gui stuff
   uiName = "Vulcan";
   iconName = "./icon_Vulcan";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

    // Dynamic properties defined by the scripts
   image = VulcanImage;
   canDrop = true;

   TT_ammoType = "50Cal";
   TT_reloads = true;
   TT_maxAmmo = 200;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(VulcanImage)
{
   // Basic Item properties
   shapeFile = "./Vulcan.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = VulcanItem;
   ammo = " ";
   projectile = VulcanProjectile1;
   projectileType = Projectile;

   casing = BigShellDebris;
   shellExitDir        = "0 1 -1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = VulcanItem.colorShiftColor;

   // hook into Support_ImageAltTrigger
   altTriggerEnabled = true;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.05;
   stateSequence[0]                  = "Activate";
   stateTransitionOnTimeout[0]       = "LoadCheckA";
   stateSound[0]              = weaponSwitchSound;

   stateName[1]                     = "Ready";
   stateScript[1]                   = "onReady";
   stateTransitionOnNotLoaded[1]       = "Reload";
   stateTransitionOnTriggerDown[1]  = "SpinUp";
   stateAllowImageChange[1]         = true;

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Delay";
   stateTimeoutValue[2]            = 0; //0.05
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateScript[2]                  = "onFire";
   stateEjectShell[2]           = true;
   stateEmitter[2]               = gunFlashEmitter;
   stateEmitterTime[2]           = 0.05;
   stateEmitterNode[2]           = "muzzleNode";
   stateWaitForTimeout[2]        = true;
   stateSound[2]              = "VulcanFireSound";

   stateName[3]                 = "Delay";
   stateTransitionOnTimeout[3]     = "FireLoadCheckA";
   stateSound[3]                   = "VulcanSpinSound";
   stateTimeoutValue[3]            = 0.032; // 0.05
   stateSequence[3]                = "Firespin";
   stateEmitter[3]               = gunSmokeEmitter;
   stateEmitterTime[3]           = 0.03;
   stateEmitterNode[3]           = "muzzleNode";

   stateName[4]            = "LoadCheckA";
   stateScript[4]          = "TT_onLoadCheck";
   stateTimeoutValue[4]       = 0.01;
   stateTransitionOnTimeout[4]      = "LoadCheckB";

   stateName[5]            = "LoadCheckB";
   stateTransitionOnLoaded[5]      = "Ready";
   stateTransitionOnNotLoaded[5]    = "Empty";

   stateName[6]            = "Reload";
   stateTimeoutValue[6]       = 3.5; //1.6
   stateScript[6]          = "onReloadStart";
   stateTransitionOnTimeout[6]      = "Wait";
   stateWaitForTimeout[6]        = true;

   stateName[7]            = "Wait";
   stateTimeoutValue[7]       = 0.768; // 0.8
   stateScript[7]          = "onReloadWait";
   stateTransitionOnTimeout[7]     = "Reloaded";

   // remove stateSound if we want pure fire sounds (makes them sound more rapid)
   // spinning sound is amplified by having stateSound play here
   stateName[8]            = "FireLoadCheckA";
   stateScript[8]          = "TT_onLoadCheck";
   stateSound[8]           = "VulcanSpinSound";
   stateTimeoutValue[8]       = 0.032;
   stateTransitionOnTimeout[8]      = "FireLoadCheckB";

   stateName[9]            = "FireLoadCheckB";
   stateTransitionOnLoaded[9]      = "Smoke";
   stateTransitionOnNotLoaded[9]    = "ReloadSmoke";

   stateName[10]           = "Smoke";
   stateEmitter[10]        = gunSmokeEmitter;
   stateEmitterTime[10]       = 0.3;
   stateEmitterNode[10]       = "muzzleNode";
   stateTimeoutValue[10]         = 0.1;
   stateSequence[10]                   = "Firespin";
   stateTransitionOnTimeout[10]     = "Restore";
   stateTransitionOnTriggerDown[10] = "FireCheckA";
   stateSound[10]                          = "VulcanSpinSound";

   stateName[11]           = "ReloadSmoke";
   stateEmitter[11]        = gunSmokeEmitter;
   stateEmitterTime[11]       = 0.85;
   stateEmitterNode[11]       = "muzzleNode";
   stateSound[11]                  = "VulcanWindDownSound";
   stateScript[11]                 = "onRestore";
   stateSequence[11]               = "WindDown";
   stateTimeoutValue[11]         = 1;
   stateTransitionOnTimeout[11]    = "EmptyFire";

   stateName[12]           = "Reloaded";
   stateTimeoutValue[12]         = 0.064; // 0.01
   stateScript[12]            = "onReloaded";
   stateTransitionOnTimeout[12]    = "Ready";

   stateName[13]                           = "SpinUp";
   stateTimeoutValue[13]                   = 0.85;
   stateScript[13]                         = "onSpinUp";
   stateSequence[13]                       = "WindUp";
   stateSound[13]                         = "VulcanWindUpSound";
   stateTransitionOnTimeout[13]           = "SpinCheck";

   stateName[14]                           = "SpinCheck";
   stateTransitionOnTriggerDown[14]        = "FireCheckA";
   stateTransitionOnTriggerUp[14]          = "Restore";

   stateName[15]                          = "Restore";
   stateTimeoutValue[15]                  = 0.85;
   stateScript[15]                        = "onRestore";
   stateSequence[15]                      = "WindDown";
   stateSound[15]                         = "VulcanWindDownSound";
   stateTransitionOnTimeout[15]           = "LoadCheckA";

   stateName[16]                     = "FireCheckA";
   stateScript[16]                   = "TT_onFireCheck";
   stateTransitionOnTimeout[16]      = "FireCheckB";

   stateName[17]                     = "FireCheckB";
   stateTransitionOnLoaded[17]       = "Fire";
   stateTransitionOnNotLoaded[17]    = "Restore";

   stateName[18]                    = "EmptyFire";
   stateTransitionOnLoaded[18]      = "Ready";
   stateTransitionOnAmmo[18]        = "Reload";
   stateTransitionOnTriggerUp[18]   = "Empty";

   stateName[19]                    = "Empty";
   stateTransitionOnLoaded[19]      = "Ready";
   stateTransitionOnAmmo[19]        = "Reload";
   stateTransitionOnTriggerDown[19] = "SpinUp";
};

function VulcanImage::onFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   if(vectorLen(%obj.getVelocity()) < 0.1)
   {
      %spread = 0.0055; //0.0040
   }
   else
   {
      %spread = 0.0060; //0.0070
   }
   %shellcount = 1;

   %obj.playThread(2, plant);

   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function VulcanImage::onReloadStart(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, shiftRight);
   serverPlay3D(block_MoveBrick_Sound, %obj.getPosition());
}

function VulcanImage::onReloadWait(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, plant);
   serverPlay3D(FWReload2Sound, %obj.getPosition());
}

function VulcanImage::onReloaded(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return %obj.setImageLoaded(%slot, 1);
   %this.TT_reload(%obj, %slot);
   %this.TT_displayAmmo(%obj);
}

function VulcanProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      TT_dampenVelocity(%col, 1.2);
   }
   Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}

function VulcanImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   %obj.popDatablock(SlowedArmor.getID());
}

function VulcanImage::onSpinUp(%this,%obj,%slot)
{
   %this.TT_displayAmmo(%obj);
   if($Pref::Server::FW::VulcanSlow)
      %obj.pushDatablock(SlowedArmor.getID());
}

function VulcanImage::onRestore(%this,%obj,%slot)
{
   %obj.popDatablock(SlowedArmor.getID());
}

function VulcanImage::onAltTrigger(%this,%obj,%objDB,%triggerSlot,%val)
{
   if(%val && %triggerSlot == 4 && $Pref::Server::FW::VulcanDeploy)
   {
      %obj.TT_retainImageAmmo = 1;
      %obj.mountImage(VulcanDeployedImage, 0);
      %obj.pushDatablock(DeployedArmor.getID());
      %obj.setVelocity("0 0 0");
   }
}

datablock ShapeBaseImageData(VulcanDeployedImage)
{
   // Basic Item properties
   shapeFile = "./VulcanDeployed.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0"; //0 0 0
   eyeOffset = "0 1.2 -0.8"; //"0.7 1.2 -0.5"; "0"
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = VulcanItem;
   ammo = " ";
   projectile = VulcanProjectile1;
   projectileType = Projectile;

   casing = BigShellDebris;
   shellExitDir        = "0 1 -1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = VulcanItem.colorShiftColor;

   // hook into Support_ImageAltTrigger
   altTriggerEnabled = true;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.05;
   stateSequence[0]                  = "Activate";
   stateTransitionOnTimeout[0]       = "DeployDelay";
   stateSound[0]              = weaponSwitchSound;

   stateName[1]                     = "Ready";
   stateScript[1]                   = "onReady";
   stateTransitionOnNotLoaded[1]       = "Reload";
   stateTransitionOnTriggerDown[1]  = "SpinUp";
   stateAllowImageChange[1]         = true;

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Delay";
   stateTimeoutValue[2]            = 0; //0.05
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateScript[2]                  = "onFire";
   stateEjectShell[2]           = true;
   stateEmitter[2]               = gunFlashEmitter;
   stateEmitterTime[2]           = 0.05;
   stateEmitterNode[2]           = "muzzleNode";
   stateWaitForTimeout[2]        = true;
   stateSound[2]              = "VulcanFireSound";

   stateName[3]                 = "Delay";
   stateTransitionOnTimeout[3]     = "FireLoadCheckA";
   stateSound[3]                   = "VulcanSpinSound";
   stateTimeoutValue[3]            = 0.032; // 0.05
   stateSequence[3]                = "Firespin";
   stateEmitter[3]               = gunSmokeEmitter;
   stateEmitterTime[3]           = 0.03;
   stateEmitterNode[3]           = "muzzleNode";

   stateName[4]            = "LoadCheckA";
   stateScript[4]          = "TT_onLoadCheck";
   stateTimeoutValue[4]       = 0.01;
   stateTransitionOnTimeout[4]      = "LoadCheckB";

   stateName[5]            = "LoadCheckB";
   stateTransitionOnLoaded[5]      = "Ready";
   stateTransitionOnNotLoaded[5]    = "Empty";

   stateName[6]            = "Reload";
   stateTimeoutValue[6]       = 3.5; //1.6
   stateScript[6]          = "onReloadStart";
   stateTransitionOnTimeout[6]      = "Wait";
   stateWaitForTimeout[6]        = true;

   stateName[7]            = "Wait";
   stateTimeoutValue[7]       = 0.768; // 0.8
   stateScript[7]          = "onReloadWait";
   stateTransitionOnTimeout[7]     = "Reloaded";

   // remove stateSound if we want pure fire sounds (makes them sound more rapid)
   // spinning sound is amplified by having stateSound play here
   stateName[8]            = "FireLoadCheckA";
   stateScript[8]          = "TT_onLoadCheck";
   stateSound[8]           = "VulcanSpinSound";
   stateTimeoutValue[8]       = 0.032;
   stateTransitionOnTimeout[8]      = "FireLoadCheckB";

   stateName[9]            = "FireLoadCheckB";
   stateTransitionOnLoaded[9]      = "Smoke";
   stateTransitionOnNotLoaded[9]    = "ReloadSmoke";

   stateName[10]           = "Smoke";
   stateEmitter[10]        = gunSmokeEmitter;
   stateEmitterTime[10]       = 0.3;
   stateEmitterNode[10]       = "muzzleNode";
   stateTimeoutValue[10]         = 0.1;
   stateSequence[10]                   = "Firespin";
   stateTransitionOnTimeout[10]     = "Restore";
   stateTransitionOnTriggerDown[10] = "FireCheckA";
   stateSound[10]                          = "VulcanSpinSound";

   stateName[11]           = "ReloadSmoke";
   stateEmitter[11]        = gunSmokeEmitter;
   stateEmitterTime[11]       = 0.85;
   stateEmitterNode[11]       = "muzzleNode";
   stateSound[11]                  = "VulcanWindDownSound";
   stateScript[11]                 = "onRestore";
   stateSequence[11]               = "WindDown";
   stateTimeoutValue[11]         = 1;
   stateTransitionOnTimeout[11]    = "EmptyFire";

   stateName[12]           = "Reloaded";
   stateTimeoutValue[12]         = 0.064; // 0.01
   stateScript[12]            = "onReloaded";
   stateTransitionOnTimeout[12]    = "Ready";

   stateName[13]                           = "SpinUp";
   stateTimeoutValue[13]                   = 0.85;
   stateScript[13]                         = "onSpinUp";
   stateSequence[13]                       = "WindUp";
   stateSound[13]                         = "VulcanWindUpSound";
   stateTransitionOnTimeout[13]           = "SpinCheck";

   stateName[14]                           = "SpinCheck";
   stateTransitionOnTriggerDown[14]        = "FireCheckA";
   stateTransitionOnTriggerUp[14]          = "Restore";

   stateName[15]                          = "Restore";
   stateTimeoutValue[15]                  = 0.85;
   stateSequence[15]                      = "WindDown";
   stateSound[15]                         = "VulcanWindDownSound";
   stateTransitionOnTimeout[15]           = "LoadCheckA";

   stateName[16]                     = "FireCheckA";
   stateScript[16]                   = "TT_onFireCheck";
   stateTransitionOnTimeout[16]      = "FireCheckB";

   stateName[17]                     = "FireCheckB";
   stateTransitionOnLoaded[17]       = "Fire";
   stateTransitionOnNotLoaded[17]    = "Restore";

   stateName[18]                    = "EmptyFire";
   stateTransitionOnLoaded[18]      = "Ready";
   stateTransitionOnAmmo[18]        = "Reload";
   stateTransitionOnTriggerUp[18]   = "Empty";

   stateName[19]                    = "Empty";
   stateTransitionOnLoaded[19]      = "Ready";
   stateTransitionOnAmmo[19]        = "Reload";
   stateTransitionOnTriggerDown[19] = "SpinUp";

   stateName[20]                          = "DeployDelay";
   stateTimeoutValue[20]                  = 1.5;
   stateTransitionOnTimeout[20]           = "DeployDelayEnd";

   stateName[21]                          = "DeployDelayEnd";
   stateTimeoutValue[21]                  = 0.01;
   stateTransitionOnTimeout[21]           = "LoadCheckA";
   stateScript[21]                        = "onDeployDelayEnd";
};

function VulcanDeployedImage::onFire(%this,%obj,%slot)
{
   %projectile = %this.projectile;
   %spread = 0.0030;
   %shellcount = 1;

   %obj.playThread(2, plant);

   %this.TT_decrementAmmo(%obj);
   %this.TT_displayAmmo(%obj);

   if($Pref::Server::TT::Recoil)
      %obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

   return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function VulcanDeployedImage::onReloadStart(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, plant);
   serverPlay3D(block_MoveBrick_Sound, %obj.getPosition());
}

function VulcanDeployedImage::onReloadWait(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return;
   %this.TT_displayAmmo(%obj);
   %obj.playThread(2, plant);
   serverPlay3D(FWReload2Sound, %obj.getPosition());
}

function VulcanDeployedImage::onReloaded(%this,%obj,%slot)
{
   if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
      return %obj.setImageLoaded(%slot, 1);
   %this.TT_reload(%obj, %slot);
   %this.TT_displayAmmo(%obj);
}

function VulcanDeployedImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   %this.TT_displayAmmo(%obj);
   %obj.pushDatablock(DeployedArmor.getID());
   %obj.playThread(1, armReadyBoth);
}

function VulcanDeployedImage::onUnMount(%this,%obj,%slot)
{
   fixArmReady(%obj);
   Parent::onUnMount(%this, %obj, %slot);
   %obj.popDatablock(DeployedArmor.getID());
}

function VulcanDeployedImage::onSpinUp(%this,%obj,%slot)
{
   %this.TT_displayAmmo(%obj);
}

function VulcanDeployedImage::onDeployDelayEnd(%this,%obj,%slot)
{
   %obj.playThread(2, plant);
   serverPlay3D(FWReload1Sound,%obj.getPosition());
}

function VulcanDeployedImage::onAltTrigger(%this,%obj,%objDB,%triggerSlot,%val)
{
   if(%val && %triggerSlot == 4)
   {
      %obj.TT_retainImageAmmo = 1;
      %obj.mountImage(VulcanImage, 0);
      %obj.popDatablock(DeployedArmor.getID());
   }
}
